/********************************************************************************/
/*			                                                        */
/*	Project  : P A P Y R U S  Toolkit                                       */
/*	File     : Papyrus3.h                                                   */
/*	Function : contains the declarations of types, enumerated types,        */
/*                 constants and global variables                               */
/********************************************************************************/


#ifndef Papyrus3H 
#define Papyrus3H

#ifdef FILENAME83	
#undef FILENAME83	
#endif

#include <string.h>

/* BEWARE : Mac must be defined only if we are on a Mac architecture. */

#ifndef unix
#ifndef hpux
#ifndef __alpha
#ifndef _WINDOWS
#ifndef Mac
#define Mac
#endif
#endif
#endif
#endif
#endif


#ifndef _WINDOWS
#ifndef Mac
#ifdef hpux
#include <sys/unistd.h>
#else
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#endif
#endif
#endif


#ifdef  PAPY3_VAR
#define WHERE3
#else
#define WHERE3 extern
#endif


/* --- includes --- */

#ifndef FILENAME83		/* this is for the normal machines ... */

#ifndef PapyEnumGroups3H 	/* enumeration of the groups */
#include "PapyEnumGroups3.h"
#endif
#ifndef PapyEnumModulesH 	/* enumeration of the modules */
#include "PapyEnumModules3.h"
#endif
#ifndef PapyTypeDef3H		/* PAPYRUS type definition */
#include "PapyTypeDef3.h"
#endif
#ifndef PapyGlobalVar3H		/* PAPYRUS global variables */
#include "PapyGlobalVar3.h"
#endif
#ifndef PapyPrivFunctionDef3H	/* PAPYRUS private functions */
#include "PapyPrivFunctionDef3.h"
#endif
#ifndef PapyPubFunctionDef3H	/* PAPYRUS public functions */
#include "PapyPubFunctionDef3.h"
#endif
#ifndef PapyEalloc3H		/* interface to the PAPYRUS memory manager */
#include "PapyEalloc3.h"
#endif
#ifndef PapyFileSystem3H	/* interface to the PAPYRUS file manager */
#include "PapyFileSystem3.h"
#endif
#ifndef PapyError3H		/* interface to the PAPYRUS error manager */
#include "PapyError3.h"
#endif
#include "PapyWild3.h"
#ifndef DicomdirH	
#include "DicomDir/DicomDir.h"
#endif

#else				/* FILENAME83 defined for the DOS machines */

#ifndef PapyTypeDef3H		/* PAPYRUS type definition */
#include "PAPTD3.h"
#endif
#ifndef PapyGlobalVar3H		/* PAPYRUS global variables */
#include "PAPGLV3.h"
#endif
#ifndef PapyPrivFunctionDef3H	/* PAPYRUS private functions */
#include "PAPPRF3.h"
#endif
#ifndef PapyPubFunctionDef3H	/* PAPYRUS public functions */
#include "PAPPUF3.h"
#endif
#ifndef PapyEnumGroups3H 
#include "PAPEG3.h"
#endif
#ifndef PapyEnumModulesH 
#include "PAPEM3.h"
#endif
#ifndef PapyEalloc3H
#include "PAPALOC3.h"
#endif
#ifndef PapyFileSystem3H
#include "PAPFSYS3.h"
#endif
#ifndef PapyError3H
#include "PAPERR3.h"
#endif
#include "PAPWILD3.h"
#ifndef DicomdirH	
#include "DICOMDIR.h"
#endif
#endif 				/* FILENAME83 defined */


static inline int validAPointer( register int elemType)
{
	switch ( elemType)
	{
		case SS:
		case AT:
		case USS:
		case SL:
		case UL:
		case FL:
		case FD:
		case SQ:
			printf( "\r***** validAPointer == NO ! ElemType is not valid for value->a\r");
			return 0;
		break;
	}
	
	return 1;
}


#endif	    /* Papyrus3H */

